# Password Strength

The password strength jQuery plugin.

## Getting Started
Download the [production version][min] or the [development version][max].

[min]: https://raw.github.com/mukimov/password-strength/master/dist/password-strength.min.js
[max]: https://raw.github.com/mukimov/password-strength/master/dist/password-strength.js

In your web page:

```html
<script src="jquery.js"></script>
<script src="dist/password-strength.min.js"></script>
<script>
jQuery(function($) {
  $.passStrength();
});
</script>
```

## Documentation. 
### Options.
`minLength` Minimum length for password.

`appendTo` Html element to which you want to append results.

`messages` Container for text help

`rules` Collection of predifined rules:
```javascript
minDigits - minimal digits
minSymbols - minimal symbols
minChars - minimal chars
minUpperChars - minimal upper chars
hasRepetitionInPassword - repetitive chars or symbols (experimental)
```
### Styles and customization.
To customize styles you must edit options `poorPass,
weakPass, goodPass, strongPass`. For more
information see examples.

## Examples
```html
$("#password_input).passStrength({
  minLength: 5,
  appendTo : ".help",
  messages: ".messages",
  rules: {
    minDigits:      2,
    minSymbols:     1,
    minChars:       1,
    minUpperChars:  2,
    hasRepetitionInPassword: true //experimental
  },
  poorPass: {
    class: "poorPass",
    text: "Poor pass"
  },
  weakPass: {
    class: "weakPass",
    text: "Weak pass"
  },
  goodPass: {
    class: "goodPass",
    text: "Good pass"
  },
  strongPass: {
    class: "strongPass",
    text: "Strong pass"
  }
});
```
## Release History
0.1.0 First release

## Support or contact
Plugin distributed AS IS. You can contact me mukimov_at_gmail_dot_com. 

Copyright (c) 2013 Shukhrat Mukimov

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
