/*!jQuery Password Strength Metter Plugin - v1.0.0 - 11/30/2012
* Password Strength Meter is a jQuery plug-in provide you smart algorithm to detect a password strength. Based on Darren Mason(djmason9@gmail.com) plugin http://code.google.com/p/jquerycustomselectbox/source/browse/trunk/WebRoot/password_strength/password_strength_plugin.js.
* Plugin webpage http://mukimov.github.com/jquery-password-strength/
* Plugin source https://github.com/mukimov/jquery-password-strength
* Copyright (c) 2012 Shukhrat Mukimov(mukimov@gmail.com); LicensedMIT, GPL
*/
(function($){
  $.fn.poorPass = 'Very Poor';
  $.fn.weakPass = 'Weak';
  $.fn.goodPass = 'Good';
  $.fn.strongPass = 'Strong';
  $.fn.excellentPass = 'Excellent';
  $.fn.samePassword = 'Username and Password identical.';
  $.fn.resultStyle = "";

  $.fn.passStrength = function(options, callback){
    if($.isFunction(options)){
      callback = options;
      options = null;
    }
    var defaults = {
      minLength:5,//required
      appendTo :"",//optional
      messages :"",//optional
      rules                    :{
        preferedLength         :8,//optional
        minNums                :2,//optional
        minLowerChars          :2,//optional
        minUpperChars          :2,//optional
        minSymbols             :1,//optional
        hasLowerAndUpperChars  :false,//optional
        hasNumbersAndChars     :false,//optional
        hasNumbersAndSymbols   :false,//optional
        hasCharsAndSymbols     :false,//optional
        hasRepetitionInPassword:0//optional
      },
      complete     :"",
      poorPass     :"poorPass",//optional
      weakPass     :"weakPass",//optional
      goodPass     :"goodPass",//optional
      strongPass   :"strongPass",//optional
      excellentPass:"excellentPass",//optional
      baseStyle    :"testresult",//optional if appendTo is defined, baseStyle will be skipped
      userid       :"",//optional
      messageloc   :1//before ==0orafter ==1
    };
    var opts = $.extend(true, {}, defaults, options);

    return this.each(function(){
      var obj = $(this);
      var messages = new Array();
      $(obj).unbind().keyup(function(){
        var results = $.fn.teststrength($(this).val(),$(opts.userid).val(),opts);

        if(opts.messageloc === 1)
        {
          if(opts.appendTo.length>0){
            $(this).siblings("." + opts.appendTo).find("span").remove();
            $(this).siblings("." + opts.appendTo).removeClass().addClass(opts.appendTo).addClass($(this).resultStyle).append("<span>" + results + "</span>");
          }else{
            $(this).next("." + opts.baseStyle).remove();
            $(this).after("<span class = \"" + opts.baseStyle + "\"><span></span></span>");
            $(this).next("." + opts.baseStyle).addClass($(this).resultStyle).find("span").text(results);
          }
        }
        else
          {	if(opts.appendTo.length>0){
            $(this).siblings("." + opts.appendTo).find("span").remove();
            $(this).siblings("." + opts.appendTo).removeClass().addClass(opts.appendTo).addClass($(this).resultStyle).append("<span>" + results + "</span>");
          }else{
            $(this).prev("." + opts.baseStyle).remove();
            $(this).before("<span class = \"" + opts.baseStyle + "\"><span></span></span>");
            $(this).prev("." + opts.baseStyle).addClass($(this).resultStyle).find("span").text(results);
          }
        }
      });

      //FUNCTIONS
      $.fn.teststrength = function(password,username,option){
        username = typeof username !== 'undefined' ? username : "";//check for user name not null
        var score = 0;
        var increase = 1;//increase score by
        $.map(option.rules,function(value){//compute increase rate
          if(value !=  0 || value !==  false){
            increase += 1;
          }
        });
        //password < option.minLength
        if(password.length < option.minLength){ 
          $(option.messages).text("Minimun length " + option.minLength);
          this.resultStyle = option.poorPass;
          return $(this).poorPass;
        }
        //password  == username
        if(password.toLowerCase() == username.toLowerCase()){ 
          $(option.messages).text($(this).samePassword);   
          this.resultStyle = option.weakPass;
          return $(this).poorPass;
        }

        var testRules = new Array();
        messages = new Array();
        testRules[0] = function(){
          //password has min numbers
          var minNums = option.rules.minNums;
          var matched = password.match(new RegExp("[0-9]", "g"));
          return !minNums || $.fn.applyRule(matched, minNums, "number");
        };
        testRules[1] = function(){
          //password has min symbols
          var minSymbols = option.rules.minSymbols;
          var matched = password.match(new RegExp("[!,@,#,$,%,^,&,*,?,_,~]", "g"));
          return !minSymbols || $.fn.applyRule(matched, minSymbols, "symbol");
        };
        testRules[2] = function(){
          //password has min lowercase chars
          var minLowerChars = option.rules.minLowerChars;
          var matched = password.match(new RegExp("[a-z]", "g"));
          return !minLowerChars || $.fn.applyRule(matched, minLowerChars, "lower character");
        };
        testRules[3] = function(){
          //password has min upper case chars
          var minUpperChars = option.rules.minUpperChars;
          var matched = password.match(new RegExp("[A-Z]", "g"));
          return !minUpperChars || $.fn.applyRule(matched, minUpperChars, "upper character");
        };
        testRules[4] = function(){
          //password has Upper and Lower chars
          return option.rules.hasLowerAndUpperChars && password.match(/([a-z].*[A-Z])|([A-Z].*[a-z])/);
        };
        testRules[5] = function(){
          //password has number and chars
          return option.rules.hasNumbersAndChars && password.match(/([a-zA-Z])/) && password.match(/([0-9])/);
        };
        testRules[6] = function(){
          //password has number and symbol
          return option.rules.hasNumbersAndSymbols && password.match(/([!,@,#,$,%,^,&,*,?,_,~])/) && password.match(/([0-9])/);
        };
        testRules[7] = function(){
          //password has char and symbol
          return option.rules.hasCharsAndSymbols && password.match(/([!,@,#,$,%,^,&,*,?,_,~])/) && password.match(/([a-zA-Z])/);
        };
        testRules[8] = function(){
          //passwordhaspreferedlength
          return option.rules.preferedLength <=  password.length;
        };
        testRules[9] = function(){
          return option.rules.hasRepetitionInPassword.enabled && (($.fn.checkRepetition(option.hasRepetitionInPassword.count, password).length - password.length) * 1) > 0;
        };

        $.each(testRules, function(index,testRule){
          if(testRule()){
            if(increase > 0){
              score += 100/increase;
            }
          }
        });

        if(option.messages.length > 0){
          $(option.messages).text(messages.length > 0 ? "Please add " + ($.fn.conjoin(messages, { separator: ', ', last: ' and '})) : "Prefered length " + option.preferedLength);
        }
        //verifying 0 < score < 100
        if(score < 0){score = 0;}
        if(score > 100){score = 100;}
        if(score < 30){this.resultStyle = option.weakPass; return $(this).weakPass;}
        if(score < 50){this.resultStyle = option.goodPass; return $(this).goodPass;}
        if(score < 70){this.resultStyle = option.strongPass; return $(this).strongPass;}

        $.isFunction(callback) && callback();
        this.resultStyle = option.excellentPass;
        return $(this).excellentPass;
      };
      $.fn.applyRule = function(matched,context,message){
        if(!!matched){
          if(matched.length < context){
            if(matched.length == 1){
              messages.push($.fn.addMessage(matched.length, message));
            }else{
              messages.push($.fn.addMessage(matched.length, message + "s"));
            }
          }else{
            return true;
          }
        }else{
          if(context == 1){
            messages.push($.fn.addMessage(context, message));
          }else{
            messages.push($.fn.addMessage(context, message + "s"));
          }
        }
        return false;
      };
      $.fn.addMessage = function(length, message){
        return $.fn.conjoin([length, "more", message], { separator: " ", last: " "});
      };
    });
  };
})(jQuery);

$.fn.checkRepetition = function(pLen,str){
  var res = "";
  for(var i = 0; i < str.length; i++)
  {
    var repeated = true;

    for(var j = 0; j < pLen && (j + i + pLen) < str.length; j++){
      repeated = repeated && (str.charAt(j + i) == str.charAt(j + i + pLen));
    }
    if(j < pLen){ repeated = false;}
    if(repeated){
      i += pLen - 1;
      repeated = false;
    }
    else{
      res += str.charAt(i);
    }
  }
  return res;
};
$.fn.conjoin = function(array, args){
  if(array.length < 2){
    return array[0];
  }
  var result = "";

  var separator = args['separator'] || ' ';
  var lastSep = args['last'] || ' and ';
  var last = array.length - 1;
  $.each(array, function(index, value){
    if(index + 1 == last){result += value;}
    else if(index == last){
      result += lastSep + value;
    }
    else{
      result += value + separator;  
    }
  });
  return result;
}
